#include <stdlib.h>

void strcat(char *dest, const char *src)
{
   int len = strlen(dest);
   dest += len;
   while (( *dest++ = *src++) != 0) {
   }
}


int strncmp(const char *s1, const char *s2, int len)
{
   int i = 0;
   int c1, c2;
   if (s1 == NULL || s2 == NULL)
      return -1;
   for (c1 = s1[i], c2 = s2[i]; i < len; c1 = s1[i], c2 = s2[i], i++) {
      if (c1 < c2)
         return -1;
      else if (c1 > c2)
         return 1;
      else
         continue;
   }
   return 0;
}

int strcmp(const char *s1, const char *s2)
{
   int l1 = strlen(s1);
   int l2 = strlen(s2);
   int l = (l1 < l2) ? l1 : l2;
   int result = strncmp(s1, s2, l);
   if (l == 0 && (l1 != l2)) {
      if (l1 < l2)
         return -1;
      else
         return 1;
   } else {
      return result;
   }
}


/*
 * very simple memcpy to blast bits around from place to place
 */
void *memcpy(void  *dst, const void *src, long n)
{
  if (   (((char)dst)&3) == 0
         && (((char)src)&3) == 0
         && (n&3) == 0 ) {
    unsigned long *ca,*cb;
    for (ca = (unsigned long *)dst, cb = (unsigned long *)src; n > 0;n -= 4)
      *ca++ = *cb++;
  } else {
    char *ca,*cb;
    for (ca = (char *)dst, cb = (char *)src; n-- > 0;)
      *ca++ = *cb++;
  }
  return dst;
}


/*
 * memset routine: fills first n bytes of dst with value c
 */
void memset(void *dst, char c, unsigned long n)
{
  char *ca;
  for (ca = (char *)dst; n-- > 0; )
    *ca++ = c;
}


