
#include <uart.h>

	.text
	
	.global	_InitUART
	.global _putc

	.text
	.align 2



	/*
	;; ********************************************************************
	;; InitUART - Initialize Serial Communications
	;; ********************************************************************
	;; Following reset, the UART is disabled. So, we do the following:
	*/
_InitUART:

	ldr	r3, UART_BASE
	mov	r1, #0
	str	r1, [r3, #UTCR3]
	mov	r1, #0x08		@ 8N1
	str	r1, [r3, #UTCR0]
	mov	r1, #BAUD_DIV
	str	r1, [r3, #UTCR2]
	mov	r1, r1, lsr #8
	str	r1, [r3, #UTCR1]
	mov	r1, #0x03		@ RXE + TXE
	str	r1, [r3, #UTCR3]
	mov	r1, #0xff		@ flush status reg
	str	r1, [r3, #UTSR0]
	MOV	pc, lr		/* All done, return*/

	/*
	;; ********************************************************************
	;; putc -- prints the character in R0
        ;;   Reads r0, writes r0 with RXSTAT, modifies r0,r1,r2
	;;********************************************************************
	*/
_putc:	

	ldr	r3, UART_BASE
	mov	r1, r0
1:	ldr	r2, [r3, #UTSR1]
	tst	r2, #1 << 2		@ UTSR1_TNF
	beq	1b
/*	teq	r1, #'\n' 
	moveq	r1, #'\r' */
	str	r1, [r3, #UTDR]
	mov	pc, lr


	.align
UART_BASE:	.long	0x80050000		@ UART3
